/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Defines the URL file extension condition for the delivery rule.
 *
 * @extends models['DeliveryRuleCondition']
 */
class DeliveryRuleUrlFileExtensionCondition extends models['DeliveryRuleCondition'] {
  /**
   * Create a DeliveryRuleUrlFileExtensionCondition.
   * @member {object} parameters Defines the parameters for the condition.
   * @member {array} [parameters.extensions] A list of extensions for the
   * condition of the delivery rule.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DeliveryRuleUrlFileExtensionCondition
   *
   * @returns {object} metadata of DeliveryRuleUrlFileExtensionCondition
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UrlFileExtension',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'name',
          clientName: 'name'
        },
        uberParent: 'DeliveryRuleCondition',
        className: 'DeliveryRuleUrlFileExtensionCondition',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          parameters: {
            required: true,
            serializedName: 'parameters',
            defaultValue: {},
            type: {
              name: 'Composite',
              className: 'UrlFileExtensionConditionParameters'
            }
          }
        }
      }
    };
  }
}

module.exports = DeliveryRuleUrlFileExtensionCondition;
