/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Defines the parameters for the URL path condition.
 *
 */
class UrlPathConditionParameters {
  /**
   * Create a UrlPathConditionParameters.
   * @member {string} path A URL path for the condition of the delivery rule
   * @member {string} matchType The match type for the condition of the
   * delivery rule. Possible values include: 'Literal', 'Wildcard'
   */
  constructor() {
  }

  /**
   * Defines the metadata of UrlPathConditionParameters
   *
   * @returns {object} metadata of UrlPathConditionParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UrlPathConditionParameters',
      type: {
        name: 'Composite',
        className: 'UrlPathConditionParameters',
        modelProperties: {
          odatatype: {
            required: true,
            isConstant: true,
            serializedName: '@odata\\.type',
            defaultValue: 'Microsoft.Azure.Cdn.Models.DeliveryRuleUrlPathConditionParameters',
            type: {
              name: 'String'
            }
          },
          path: {
            required: true,
            serializedName: 'path',
            type: {
              name: 'String'
            }
          },
          matchType: {
            required: true,
            serializedName: 'matchType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = UrlPathConditionParameters;
